VERSION 5.00
Begin VB.UserControl oAnalogClock 
   ClientHeight    =   4470
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4920
   ScaleHeight     =   4470
   ScaleWidth      =   4920
   ToolboxBitmap   =   "oAnalogClock.ctx":0000
   Begin VB.Timer tmrUhr 
      Left            =   4200
      Top             =   1440
   End
   Begin VB.PictureBox Pic 
      Height          =   3960
      Left            =   0
      ScaleHeight     =   3900
      ScaleWidth      =   3795
      TabIndex        =   0
      Top             =   0
      Width           =   3855
   End
   Begin VB.Menu mnuPopUp 
      Caption         =   "PopUp"
      Begin VB.Menu mnundern 
         Caption         =   "Systemzeit und -datum ndern"
      End
   End
End
Attribute VB_Name = "oAnalogClock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'**********************************************************
' FARBVERLAUF IN FENSTERN UND OBJEKTEN
' zunchst die bentigten API-Funktionen
Private Declare Function DeleteObject Lib "gdi32" _
  (ByVal hObject As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" _
  (ByVal crColor As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" _
(ByVal hDC As Long, ByVal nIndex As Long) As Long
Private Declare Function FillRect Lib "user32" _
  (ByVal hDC As Long, lpRect As RECT, _
  ByVal hBrush As Long) As Long

Private Const PLANES = 14
Private Const BITSPIXEL = 12

'Private Type RECT
'  Left As Long
'  Top As Long
'  Right As Long
'  Bottom As Long
'End Type

Private Declare Function SetLayeredWindowAttributes Lib "USER32.DLL" (ByVal hWnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long

Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_LAYERED = &H80000

'********************************************************************
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" _
(ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
(ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Declare Function SetWindowPos Lib "user32" _
(ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, _
ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

'================================================================
'Dieser Source stammt teilweise von http://www.vb-fun.de,
'http://www.vbarchiv.de und
'http://www.Visual-Basic5.de Free Sourcecode
'(Heinz Prelle, Lenbachstrae 42, 30655 Hannover, info@ visual - basic5.de)
'u.a.
'und kann frei
'in EIGENEN (auch in EIGENEN kommerziellen) Projekten verwendet
'werden. Er darf NICHT auf anderen Webseiten oder Foren ohne
'Quellenangabe verffentlicht werden (siehe hierzu auch die
'Hinweise unter "Urheber- und Kennzeichenrecht" im Impressum).
'Fr eventuelle Schden wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

'================================================================
'Mehrzeiliger ToolTipp
'erstellt von: Ralph Steinknig
'================================================================

' Verschiedene Typdeklarationen fr die API-Funktionen
Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Type TOOLINFO
  cbSize As Long
  uFlags As Long
  hWnd As Long
  uId As Long
  cRect As RECT
  hinst As Long
  lpszText As String
End Type

'Die Funktion CreateWindowEx erzeugt ein berlappendes, PopUp- oder
' abgeleitetes Fenster mit erweitertem Stil.
Private Declare Function CreateWindowEx Lib "user32" Alias _
      "CreateWindowExA" (ByVal dwExStyle As Long, _
      ByVal lpClassName As String, ByVal lpWindowName As String, _
      ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, _
      ByVal nWidth As Long, ByVal nHeight As Long, _
      ByVal hWndParent As Long, ByVal Hmenu As Long, _
      ByVal hInstance As Long, lpParam As Any) As Long
  
'DestroyWindow lscht das durch hwnd angegebene Fenster.
Private Declare Function DestroyWindow Lib "user32" _
      (ByVal hWnd As Long) As Long

'Initialisierung CommonControls
Private Declare Sub InitCommonControls Lib "comctl32.dll" ()

'SendMessage
Private Declare Function SendMessage Lib "USER32.DLL" Alias _
      "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, _
      ByVal wParam As Long, lParam As Any) As Long

Private Const WM_USER = &H400
Private Const TTM_ADDTOOL = WM_USER + 4
Private Const TTM_SETMAXTIPWIDTH = WM_USER + 24
Private Const TTF_IDISHWND = &H1
Private Const TTF_SUBCLASS = &H10
Private Const SWP_NOMOVE = &H2

Private Const SWP_NOSIZE = &H1

Private Const SWP_NOOWNERZORDER = &H200      '  Don't do owner Z ordering

Private Const SWP_NOZORDER = &H4

Private Const SWP_FRAMECHANGED = &H20        '  The frame changed: send WM_NCCALCSIZE

' Window-Handle des erzeugten ToolTip-Fensters
Private hToolTip As Long
'================================================================

Public Enum picBorderStyle
    [kein] = 0
    [fest einfach] = 1
    [erhht] = 2
    [Rahmen] = 3
End Enum

Const Pi As Double = 3.14159265359
Const Rad As Double = 180 / Pi

'3 Zeiger mit X und Y Koordinate
Dim Zeiger(1 To 3, 1 To 2) As Integer
Dim Bewegung As Integer

Dim WertMinuten As Currency
Dim WertSekunden As Currency

Dim Stundenzahl As Long
Dim Stundenwert As Currency
Dim EigenerTimerWert As Currency

Dim Sec As Byte     'Sekunden
Dim Min As Byte     'Minuten
Dim Stu As Double   'Stunden

Dim X As Long
Dim Y As Long
Dim X1 As Long, Y1 As Long
Dim DtGr As Long

Dim Mitte As Long
Dim hasFocus As Boolean

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" _
(ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, _
ByVal lpParameters As String, ByVal lpDirectory As String, _
ByVal nShowCmd As Long) As Long

Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long

Private Declare Function ReleaseDC Lib "user32" _
(ByVal hWnd As Long, ByVal hDC As Long) As Long

Const HORZRES = 8
Const VERTRES = 10

'******************************************************************************
'******************************************************************************
'Feiertage berechnen und ausgeben
'******************************************************************************

Private Enum eFeiertage
    Weiberfastnacht = -52
    Fastnacht = -47
    Rosenmontag = -48
    Aschermittwoch = -46
    Grndonnerstag = -3
    Karfreitag = -2
    Karsamstag = -1
    Ostersonntag = 0
    Ostermontag = 1
    Christihimmelfahrt = 39
    Pfingstsonntag = 49
    Pfingstmontag = 50
    Fronleichnam = 60
End Enum

'wird gebraucht in der Feiertaganzeigen-Prozedur

Dim Muttertag As Date
Dim Erntedankfest As Date
Dim Valentinstag As Date
Dim EisheiligenMamertus As Date
Dim EisheiligenPankratius As Date
Dim EisheiligenServatius As Date
Dim EisheiligenBonifatius As Date
Dim EisheiligenkalteSophie As Date
Dim Siebenschlfertag As Date
Dim Friedensfest As Date
Dim MariaHimmelfahrt As Date
Dim Reformationstag As Date
Dim Allerseelen As Date
Dim Nikolaus As Date
Dim Heiligabend As Date
Dim Silvester As Date
Dim vierterAdvent As Date
Dim dritterAdvent As Date
Dim zweiterAdvent As Date
Dim ersterAdvent As Date
Dim BuundBettag As Date
Dim Totensonntag As Date
Dim Volkstrauertag As Date

Dim Neujahr As Date
Dim HeiligeDreiKnige As Date
Dim ErsterMai As Date
Dim TgdtEinheit As Variant
Dim Allerheiligen As Date
Dim ErsterWeihnachtsfeiertag As Date
Dim ZweiterWeihnachtsfeiertag As Date
'Ereignisdeklarationen:
Event Change()
Attribute Change.VB_Description = "Tritt auf, wenn sich der Inhalt eines Steuerelements gendert hat."
Event Click()
Attribute Click.VB_Description = "Tritt auf, wenn der Benutzer eine Maustaste ber einem Objekt drckt und wieder loslt."
Event DblClick()
Attribute DblClick.VB_Description = "Tritt auf, wenn der Benutzer eine Maustaste ber einem Objekt drckt und wieder loslt und anschlieend erneut drckt und wieder loslt."
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyDown
Attribute KeyDown.VB_Description = "Tritt auf, wenn der Benutzer eine Taste drckt, whrend ein Objekt den Fokus besitzt."
Event KeyPress(KeyAscii As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyPress
Attribute KeyPress.VB_Description = "Tritt auf, wenn der Benutzer eine ANSI-Taste drckt und loslt."
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyUp
Attribute KeyUp.VB_Description = "Tritt auf, wenn der Benutzer eine Taste loslt, whrend ein Objekt den Fokus hat."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Attribute MouseDown.VB_Description = "Tritt auf, wenn der Benutzer die Maustaste drckt, whrend ein Objekt den Fokus hat."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Attribute MouseMove.VB_Description = "Tritt auf, wenn der Benutzer die Maus bewegt."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp
Attribute MouseUp.VB_Description = "Tritt auf, wenn der Benutzer die Maustaste loslt, whrend ein Objekt den Fokus hat."
Event Timer() 'MappingInfo=tmrUhr,tmrUhr,-1,Timer
'Standard-Eigenschaftswerte:
Const m_def_BorderStyle = 3
Const m_def_AbstandStricheMitte = 420
Const m_def_ZifferRmisch = False
Const m_def_BooleanFocusRect = False
Const m_def_FocusColor = vbBlack
Const m_def_FocusDrawStyle = 2
Const m_def_DisabledColor = &H808080
Const m_def_MultiLineToolTipText = ""
Const m_def_AbstandDot = 1.5
Const m_def_ColorCaption = vbBlack
Const m_def_FontBoldCaption = False
Const m_def_FontSizeCaption = 8
Const m_def_Caption = ""
Const m_def_DotGre = 30
Const m_def_BorderWidthSekundenZeiger = 1
Const m_def_BorderWidthMinutenZeiger = 2
Const m_def_BorderWidthStundenZeiger = 3
Const m_def_BorderWidthStundenStriche = 2
Const m_def_BorderWidthMinutenStriche = 1
Const m_def_AbstandStricheAuen = 330
Const m_def_AbstandStricheInnen = 7
Const m_def_AbstandMinutenZiffern = 4
Const m_def_AbstandStundenZiffern = 2.25
Const m_def_Sekundenzifferanzeigen = True
Const m_def_Minutenziffernanzeigen = True
Const m_def_Stundenziffernanzeigen = True
Const m_def_Value = "00:00:00"
Const m_def_bSekunde = 0
Const m_def_bMinute = 0
Const m_def_bStunde = 0
Const m_def_FontBoldStundenZiffer = False
Const m_def_FontBoldMinutenZiffer = False
Const m_def_FontSizeMinutenZiffer = 8
Const m_def_FontSizeStundenZiffer = 8
Const m_def_FontUnderlineSekundenZiffer = True
Const m_def_FontItalicSekundenZiffer = True
Const m_def_FontBoldSekundenZiffer = True
Const m_def_FontSizeSekundenZiffer = 14
Const m_def_ColorSekundenZiffer = vbBlack
Const m_def_LngeSekundenZeiger = 1200
Const m_def_LngeStundenZeiger = 600
Const m_def_LngeMinutenZeiger = 800
Const m_def_ColorDot1 = &HE0E0E0
Const m_def_ColorDot2 = &H808080
Const m_def_ColorStundenStriche = vbBlue
Const m_def_ColorMinutenStriche = vbMagenta
Const m_def_ColorStundenZeiger = vbBlack
Const m_def_ColorMinutenZeiger = vbBlue
Const m_def_ColorSekundenZeiger = vbRed
Const m_def_ColorStundenZiffer = vbBlack
Const m_def_ColorMinutenZiffer = &H8000&
Const m_def_GradientColor1 = &HC0C0C0
Const m_def_GradientColor2 = &HFFFFFF
'Eigenschaftsvariablen:
Dim m_BorderStyle As picBorderStyle
Dim m_AbstandStricheMitte As Long
Dim m_ZifferRmisch As Boolean
Dim m_BooleanFocusRect As Boolean
Dim m_FocusColor As OLE_COLOR
Dim m_FocusDrawStyle As DrawStyleConstants
Dim m_DisabledColor As OLE_COLOR
Dim m_MultiLineToolTipText As String
Dim m_AbstandDot As Double
Dim m_ColorCaption As OLE_COLOR
Dim m_FontBoldCaption As Boolean
Dim m_FontSizeCaption As Long
Dim m_Caption As String
Dim m_DotGre As Byte
Dim m_BorderWidthSekundenZeiger As Byte
Dim m_BorderWidthMinutenZeiger As Byte
Dim m_BorderWidthStundenZeiger As Byte
Dim m_BorderWidthStundenStriche As Byte
Dim m_BorderWidthMinutenStriche As Byte
Dim m_AbstandStricheAuen As Long
Dim m_AbstandStricheInnen As Currency
Dim m_AbstandMinutenZiffern As Currency
Dim m_AbstandStundenZiffern As Currency
Dim m_Sekundenzifferanzeigen As Boolean
Dim m_Minutenziffernanzeigen As Boolean
Dim m_Stundenziffernanzeigen As Boolean
Dim m_Value As String
Dim m_bSekunde As Long
Dim m_bMinute As Long
Dim m_bStunde As Long
Dim m_FontBoldStundenZiffer As Boolean
Dim m_FontBoldMinutenZiffer As Boolean
Dim m_FontSizeMinutenZiffer As Long
Dim m_FontSizeStundenZiffer As Long
Dim m_FontUnderlineSekundenZiffer As Boolean
Dim m_FontItalicSekundenZiffer As Boolean
Dim m_FontBoldSekundenZiffer As Boolean
Dim m_FontSizeSekundenZiffer As Long
Dim m_ColorSekundenZiffer As OLE_COLOR
Dim m_LngeSekundenZeiger As Long
Dim m_LngeStundenZeiger As Long
Dim m_LngeMinutenZeiger As Long
Dim m_ColorDot1 As OLE_COLOR
Dim m_ColorDot2 As OLE_COLOR
Dim m_ColorStundenStriche As OLE_COLOR
Dim m_ColorMinutenStriche As OLE_COLOR
Dim m_ColorStundenZeiger As OLE_COLOR
Dim m_ColorMinutenZeiger As OLE_COLOR
Dim m_ColorSekundenZeiger As OLE_COLOR
Dim m_ColorStundenZiffer As OLE_COLOR
Dim m_ColorMinutenZiffer As OLE_COLOR
Dim m_GradientColor1 As OLE_COLOR
Dim m_GradientColor2 As OLE_COLOR


'Farbanteil BLAU
Private Function ColorBlue(ByVal Color As Long) As Integer
  ColorBlue = Color \ &H10000 And &HFF&
End Function

'Farbanteil GRN
Private Function ColorGreen(ByVal Color As Long) As Integer
  ColorGreen = Color \ &H100& And &HFF&
End Function

'Farbanteil ROT
Private Function ColorRed(ByVal Color As Long) As Integer
  ColorRed = Color And &HFF&
End Function

'Parameterbeschreibung
'Obj:  Form oder Picture-Objekt
'FromColor: Farbwert Anfangsfarbe
'ToColor:   Farbwert Endfarbe
'Direction: 1 = von oben nach unten
'           2 = von links nach rechts

Private Sub MakeGradient(Obj As Object, ByVal FromColor As Long, _
  ByVal ToColor As Long, ByVal Direction As Integer)

  Static ColorBits As Long
  Static RgnCnt As Integer
  
  Dim NbrPlanes As Long
  Dim BitsPerPixel As Long
  Dim AreaHeight As Long
  Dim AreaWidth As Long
  Dim prevScaleMode As Integer
  Dim IntervalX As Long
  Dim IntervalY As Long
  Dim i As Integer
  Dim r As Long
  Dim R_ColorVal As Long
  Dim G_ColorVal As Long
  Dim B_ColorVal As Long
  Dim FillArea As RECT
  Dim hBrush As Long
  Dim ColRed As Integer
  Dim ColGreen As Integer
  Dim ColBlue As Integer
 
  With Obj
    If ColorBits = 0 Then
      BitsPerPixel = GetDeviceCaps(.hDC, BITSPIXEL)
      NbrPlanes = GetDeviceCaps(.hDC, PLANES)
      ColorBits = (BitsPerPixel * NbrPlanes)
    
      Select Case ColorBits
        Case 32:  RgnCnt = 256
        Case 24:  RgnCnt = 256
        Case 16:  RgnCnt = 256
        Case 15:  RgnCnt = 32
        Case 8:   RgnCnt = 64
        Case 4:   RgnCnt = 64
        Case Else
          ColorBits = 4
          RgnCnt = 64
      End Select
    End If
    
    prevScaleMode = .ScaleMode
    .ScaleMode = 3
    AreaHeight = .ScaleHeight
    AreaWidth = .ScaleWidth
    .ScaleMode = prevScaleMode
    
    R_ColorVal = Int((ColorRed(FromColor) - _
     ColorRed(ToColor) + 1) / RgnCnt * 70)
    G_ColorVal = Int((ColorGreen(FromColor) - _
     ColorGreen(ToColor) + 1) / RgnCnt * 70)
    B_ColorVal = Int((ColorBlue(FromColor) - _
     ColorBlue(ToColor) + 1) / RgnCnt * 40)
    
    ColRed = ColorRed(ToColor) * 100
    ColGreen = ColorGreen(ToColor) * 100
    ColBlue = ColorBlue(ToColor) * 100
    
    IntervalY = Int(AreaHeight / RgnCnt * 100)
    IntervalX = Int(AreaWidth / RgnCnt * 100)
    
    With FillArea
      .Left = 0
      .Top = 0
      .Right = AreaWidth
      .Bottom = AreaHeight
    End With
        
    For i = 0 To RgnCnt - 1
      hBrush = CreateSolidBrush(RGB(ColRed / 100, _
       ColGreen / 100, ColBlue / 100))
      If Direction = 1 Then
        FillArea.Top = AreaHeight - (i * IntervalY / 100)
        r = FillRect(.hDC, FillArea, hBrush)
        FillArea.Bottom = FillArea.Top
      Else
        FillArea.Left = AreaWidth - (i * IntervalX / 100)
        r = FillRect(.hDC, FillArea, hBrush)
        FillArea.Right = FillArea.Left
      End If
      r = DeleteObject(hBrush)
      If i < RgnCnt - 1 Then
        ColRed = ColRed + R_ColorVal
        ColGreen = ColGreen + G_ColorVal
        ColBlue = ColBlue + B_ColorVal
      End If
    Next i
    
    FillArea.Top = 0
    FillArea.Left = 0
    hBrush = CreateSolidBrush(RGB(Int(ColRed / 100), _
     Int(ColGreen / 100), Int(ColBlue / 100)))
    r = FillRect(.hDC, FillArea, hBrush)
    r = DeleteObject(hBrush)
  End With
End Sub
'**********************************************************

Private Sub BorderStyleRaised(ByVal hWnd As Long, Optional ByVal Undo As Boolean)
    Dim nStyle As Long
    
    Const GWL_STYLE = (-16)
    Const WS_DLGFRAME = &H400000
    
    nStyle = GetWindowLong(hWnd, GWL_STYLE)
    If Undo Then
        nStyle = nStyle And Not WS_DLGFRAME
    Else
        nStyle = nStyle Or WS_DLGFRAME
    End If
    SetWindowLong hWnd, GWL_STYLE, nStyle
    SetWindowPos hWnd, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER Or SWP_NOZORDER Or SWP_FRAMECHANGED
End Sub

' 4. Advent berechnen
Private Function GetViertenAdvent(ByVal intJahr As Long) As Date
On Error GoTo Fehlerbehandlung
  Dim i As Long
  
  For i = 24 To 1 Step -1
    If Format$(i & ".12." & intJahr, "ddd") = "So" Then
      GetViertenAdvent = Format$(i & ".12." & intJahr, "dd.mm.yyyy")
      Exit For
    End If
  Next i
Exit Function
Fehlerbehandlung:
End Function

' Muttertag berechnen
Private Function GetMuttertag(ByVal intJahr As Long) As Date
On Error GoTo Fehlerbehandlung
  Dim w1 As Boolean
  Dim i As Long
  
  w1 = False
  For i = 1 To 31
    If Format$(i & ".5." & intJahr, "ddd") = "So" Then
      If w1 = True Then
        GetMuttertag = Format$(i & ".5." & intJahr, "dd.mm.yyyy")
        Exit For
      Else
        w1 = True
      End If
    End If
  Next i
Exit Function
Fehlerbehandlung:
End Function

' Erntedank berechnen
Private Function GetErntedankfest(ByVal intJahr As Long) As Date
On Error GoTo Fehlerbehandlung
  Dim i As Long
  
  For i = 1 To 16
    If Format$(i & ".5." & intJahr, "ddd") = "So" Then
      GetErntedankfest = Format$(i & ".10." & intJahr, "dd.mm.yyyy")
      Exit For
    End If
  Next i
Exit Function
Fehlerbehandlung:
End Function


Private Function FeiertagDatum(ByVal intJahr As Integer, Optional Feiertag As eFeiertage) As Date

    Dim X As Integer, k As Integer, m As Integer
    Dim s As Integer, a As Integer, D As Integer
    Dim r As Integer, OG As Integer, SZ As Integer
    Dim OE As Integer, OS As Integer
    Dim Monat As Integer
    
    'intJahr ist der Wert des entsprechenden Jahres
    X = intJahr
    'Eingabewert / 100
    k = Int(X / 100)
    
    m = 15 + Int((k * 3 + 3) / 4) - Int((k * 8 + 13) / 25)
    
    s = 2 - Int((3 * k + 3) / 4)
    
    a = X Mod 19
    
    D = (19 * a + m) Mod 30
    
    r = Int(D / 29) + (Int(D / 28) - Int(D / 29)) * Int(a / 11)
    
    OG = 21 + D - r
    
    SZ = 7 - (X + Int(X / 4) + s) Mod 7
    
    OE = 7 - (OG - SZ) Mod 7
    
    OS = OG + OE
    
    Monat = 3
    
If OS > 31 Then
    OS = OS - 31
    Monat = Monat + 1
End If

FeiertagDatum = DateSerial(X, Monat, OS)
    
    Select Case Feiertag
    
        Case eFeiertage.Weiberfastnacht
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Weiberfastnacht)
    
        Case eFeiertage.Fastnacht
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Fastnacht)
    
        Case eFeiertage.Rosenmontag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Rosenmontag)
            
        Case eFeiertage.Aschermittwoch
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Aschermittwoch)
            
        Case eFeiertage.Grndonnerstag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Grndonnerstag)
            
        Case eFeiertage.Karfreitag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Karfreitag)
            
        Case eFeiertage.Karsamstag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Karsamstag)
            
        Case eFeiertage.Ostersonntag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Ostersonntag)
            
        Case eFeiertage.Ostermontag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Ostermontag)

        Case eFeiertage.Christihimmelfahrt
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Christihimmelfahrt)
            
        Case eFeiertage.Pfingstsonntag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Pfingstsonntag)
            
        Case eFeiertage.Pfingstmontag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Pfingstmontag)
            
        Case eFeiertage.Fronleichnam
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Fronleichnam)
            
        Case Else
    End Select
End Function

Public Function fktFeiertagName(ByVal Jahr As Integer, ByVal Datum As Date) As String

Neujahr = "01.01." & Jahr
HeiligeDreiKnige = "06.01." & Jahr
Valentinstag = "14.02." & Jahr
ErsterMai = "01.05." & Jahr
EisheiligenMamertus = "11.05." & Jahr
EisheiligenPankratius = "12.05." & Jahr
EisheiligenServatius = "13.05." & Jahr
EisheiligenBonifatius = "14.05." & Jahr
EisheiligenkalteSophie = "15.05." & Jahr
Siebenschlfertag = "27.06." & Jahr
Friedensfest = "08.08." & Jahr
MariaHimmelfahrt = "15.08." & Jahr
Reformationstag = "31.10." & Jahr
Nikolaus = "06.12." & Jahr
Allerheiligen = "01.11." & Jahr
Allerseelen = "2.11." & Jahr
Heiligabend = "24.12." & Jahr
ErsterWeihnachtsfeiertag = "25.12." & Jahr
ZweiterWeihnachtsfeiertag = "26.12." & Jahr
Silvester = "31.12." & Jahr
Muttertag = GetMuttertag(Jahr)
Erntedankfest = GetErntedankfest(Jahr)
vierterAdvent = GetViertenAdvent(Jahr)
dritterAdvent = DateAdd("d", -7, GetViertenAdvent(Jahr))
zweiterAdvent = DateAdd("d", -14, GetViertenAdvent(Jahr))
ersterAdvent = DateAdd("d", -21, GetViertenAdvent(Jahr))
BuundBettag = DateAdd("d", -11, ersterAdvent)
Totensonntag = DateAdd("d", -28, GetViertenAdvent(Jahr))
Volkstrauertag = DateAdd("d", -35, GetViertenAdvent(Jahr))
If Jahr < 1954 Then TgdtEinheit = ""
If Jahr >= 1954 And Jahr <= 1989 Then TgdtEinheit = DateSerial(Jahr, 6, 17)
If Jahr > 1989 Then TgdtEinheit = DateSerial(Jahr, 10, 3)
            
    Select Case Datum
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Weiberfastnacht)
            fktFeiertagName = "Weiber Fastnacht"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Fastnacht)
            fktFeiertagName = "Fastnacht"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Weiberfastnacht)
            fktFeiertagName = "Weiber Fastnacht"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Aschermittwoch)
            fktFeiertagName = "Aschermittwoch"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Rosenmontag)
            fktFeiertagName = "Rosenmontag"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Grndonnerstag)
            fktFeiertagName = "Grndonnerstag"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Karfreitag)
            fktFeiertagName = "Karfreitag"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Karsamstag)
            fktFeiertagName = "Karsamstag"
            
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Ostersonntag)
            fktFeiertagName = "Ostersonntag"
            
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Ostermontag)
            fktFeiertagName = "Ostermontag"
            
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Christihimmelfahrt)
            fktFeiertagName = "Christihimmelfahrt"
            
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Pfingstsonntag)
            fktFeiertagName = "Pfingstsonntag"
            
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Pfingstmontag)
            fktFeiertagName = "Pfingstmontag"
            
        Case Valentinstag
            fktFeiertagName = "Valentinstag"
  
        Case EisheiligenMamertus
            fktFeiertagName = "Eisheiligen: Mamertus"
            
        Case EisheiligenPankratius
            fktFeiertagName = "Eisheiligen: Pankratius"
            
        Case EisheiligenServatius
            fktFeiertagName = "Eisheiligen: Servatius"
            
        Case EisheiligenBonifatius
            fktFeiertagName = "Eisheiligen: Bonifatius"
            
        Case EisheiligenkalteSophie
            fktFeiertagName = "Eisheiligen: kalte Sophie"
            
        Case MariaHimmelfahrt
            fktFeiertagName = "Maria Himmelfahrt"

        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Fronleichnam)
            fktFeiertagName = "Fronleichnam"
            
        Case Muttertag
            fktFeiertagName = "Muttertag"
            
        Case Friedensfest
            fktFeiertagName = "Friedensfest"
            
        Case Erntedankfest
            fktFeiertagName = "Erntedankfest"
            
        Case Neujahr
            fktFeiertagName = "Neujahr"
            
        Case HeiligeDreiKnige
            fktFeiertagName = "Heilige Drei Knige"
            
        Case ErsterMai
            fktFeiertagName = "Tag der Arbeit"

        Case Siebenschlfertag
            fktFeiertagName = "Siebenschlfertag"

        Case TgdtEinheit
            fktFeiertagName = "Tag der deutschen Einheit"
        
        Case Allerheiligen
            fktFeiertagName = "Allerheiligen"
        
        Case Allerseelen
            fktFeiertagName = "Allerseelen"
        
        Case Reformationstag
            fktFeiertagName = "Reformationstag"
            
        Case Volkstrauertag
            fktFeiertagName = "Volkstrauertag"
            
        Case Totensonntag
            fktFeiertagName = "Totensonntag"
            
        Case BuundBettag
            fktFeiertagName = "Bu- und Bettag"
            
        Case Nikolaus
            fktFeiertagName = "Nikolaus"
            
        Case ersterAdvent
            fktFeiertagName = "der 1. Advent"
            
        Case zweiterAdvent
            fktFeiertagName = "der 2. Advent"
            
        Case dritterAdvent
            fktFeiertagName = "der 3. Advent"
            
        Case vierterAdvent
            fktFeiertagName = "der 4. Advent"
            
        Case Heiligabend
           fktFeiertagName = "Heiligabend"
        
        Case ErsterWeihnachtsfeiertag
            fktFeiertagName = "der 1. Weihnachtsfeiertag"
            
        Case ZweiterWeihnachtsfeiertag
            fktFeiertagName = "der 2. Weihnachtsfeiertag"
        
        Case Silvester
            fktFeiertagName = "Silvester"
            
        Case Else
            fktFeiertagName = "kein Gedenk- bzw. Feiertag"
    End Select

End Function

'******************************************************************************

'******************************************************************************

Private Sub SetMultiLineToolTip(ByVal hWnd As Long, _
      ByVal sToolTip As String)
  
'ToolTipp-Text zuweisen
  Dim udtTool As TOOLINFO
  
  With udtTool
    .cbSize = Len(udtTool)
    .hWnd = hWnd
    .uFlags = TTF_IDISHWND Or TTF_SUBCLASS
    .uId = hWnd
    .lpszText = sToolTip
  End With
  SendMessage hToolTip, TTM_ADDTOOL, 0, udtTool
End Sub

Public Function fktJahreszeit(ByVal Datum As Date, ByVal Jahr As Integer) As String
'die aktuelle Jahreszeit ermitteln
Const Frhlingsanfang = "20.03."
Const Sommeranfang = "21.06."
Const Herbstanfang = "22.09."
Const Winteranfang = "21.12."

Select Case Datum
    Case Is < Frhlingsanfang & Right(Datum, 4)
        fktJahreszeit = "aktuelle Jahreszeit : Winter ( von : " _
        & Winteranfang & Jahr - 1 & "  bis : " _
        & DateAdd("d", -1, Frhlingsanfang & Jahr) & " )"
        
    Case Is < Sommeranfang & Right(Datum, 4)
        fktJahreszeit = "aktuelle Jahreszeit : Frhling ( von : " _
        & Frhlingsanfang & Jahr & "  bis : " _
        & DateAdd("d", -1, Sommeranfang & Jahr) & " )"
        
    Case Is < Herbstanfang & Right(Datum, 4)
        fktJahreszeit = "aktuelle Jahreszeit : Sommer ( von : " _
        & Sommeranfang & Jahr & "  bis : " _
        & DateAdd("d", -1, Herbstanfang & Jahr) & " )"
        
    Case Is < Winteranfang & Right(Datum, 4)
        fktJahreszeit = "aktuelle Jahreszeit : Herbst ( von : " _
        & Herbstanfang & Jahr & "  bis : " _
        & DateAdd("d", -1, Winteranfang & Jahr) & " )"
        
    Case Is >= Winteranfang & Right(Datum, 4)
        fktJahreszeit = "aktuelle Jahreszeit : Winter ( von : " _
        & Winteranfang & Jahr & "  bis : " _
        & DateAdd("d", -1, Frhlingsanfang & Jahr + 1) & " )"
        
End Select
End Function

'MESZ Anfang Mitteleuropische Sommerzeit
Private Function MESZA(Jahr As Integer) As Date
On Error GoTo Fehlerbehandlung
Dim SZAnfang As Date
    SZAnfang = CDate("31.3." & Jahr)
       MESZA = SZAnfang - Weekday(SZAnfang) + 1
Exit Function
Fehlerbehandlung:
End Function

'MESZ Ende Mitteleuropische Sommerzeit
Private Function MESZE(Jahr As Integer) As Date
On Error GoTo Fehlerbehandlung
Dim SZEnde As Date
    SZEnde = CDate("31.10." & Jahr)
       MESZE = SZEnde - Weekday(SZEnde) + 1
Exit Function
Fehlerbehandlung:
End Function

Public Function fktSommerzeit(ByVal Jahr As Integer) As String
On Error GoTo Fehlerbehandlung
'den Beginn und das Ende der Sommerzeit anzeigen
    fktSommerzeit = "Sommerzeit ist von  " _
    & Format(MESZA(Jahr), "ddd dd.mm.yyyy") _
    & "  bis  " & Format(MESZE(Jahr), "ddd dd.mm.yyyy")
Exit Function
Fehlerbehandlung:
End Function

Private Function fktTageJahr(ByVal Datum As Date) As Integer
    'die Tage des entsprechenden Jahres ausrechnen
    fktTageJahr = DateDiff("d", "01.01." & Format(Datum, "yyyy"), _
    "31.12." & Format(Datum, "yyyy")) + 1
End Function

Public Function fktTagdesJahres(ByVal Datum As Date) As String
    'zeigt den Tag des Jahres, des Datums an
    fktTagdesJahres = "Der " & Format(Datum, "dd. mmmm yyyy") _
    & " ist der " & DatePart("y", Datum) _
    & ". Tag des Jahres !"
End Function

Public Function fktRestTagedesJahres(ByVal Datum As Date) As String
    'zeigt die noch verbleibenden Tage des Jahres an
    fktRestTagedesJahres = "Das Jahr " & Year(Datum) & " hat noch " _
    & fktTageJahr(Datum) - DatePart("y", Datum) & " ganze Tage !"
End Function

Public Function fktKalenderWoche(ByVal Datum As Date) As Integer
    'die aktuelle Kalenderwoche des entsprechenden Jahres ausrechnen
    fktKalenderWoche = DatePart("ww", Datum, vbUseSystemDayOfWeek, vbUseSystem)
End Function

Public Function fktQuartal(ByVal Datum As Date) As String
    fktQuartal = "aktuelles Quartal : " & DatePart("q", Datum)
End Function

Public Function fktSchaltjahr(ByVal Datum As Date) As String
'ber die Funktion fktTageJahr _
die Anzahl der Tage des aktuellen Jahres ermitteln
'Wert abfragen
If fktTageJahr(Datum) = 365 Then  'kein Schaltjahr
    fktSchaltjahr = "Das Jahr " & Format(Datum, "yyyy") _
    & " ist kein Schaltjahr mit " & fktTageJahr(Datum) & " Tagen !"
Else    'gibt nur noch den anderen Wert 366 Tage (ist ein Schaltjahr)
    fktSchaltjahr = "Das Jahr " & Format(Datum, "yyyy") _
    & " ist ein Schaltjahr mit " & fktTageJahr(Datum) & " Tagen !"
End If
End Function

Private Function fktToolTipText() As String
'den multiline ToolTipText ausgeben
fktToolTipText = MultiLineToolTipText
End Function

Private Sub mnundern_Click()
    DoEvents
    Call Shell("rundll32.exe shell32.dll,Control_RunDLL timedate.cpl", vbNormalFocus)
End Sub

Private Sub Pic_GotFocus()
    hasFocus = True
    Call Zeitwertanzeigen
End Sub

Private Sub Pic_LostFocus()
    hasFocus = False
    Call Zeitwertanzeigen
End Sub

Private Sub Pic_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)

    If Button = 2 Then
        UserControl.PopupMenu mnuPopUp
    End If
End Sub

Private Sub UserControl_Initialize()
'----------------------------------------------------------------------
'Initialisierung
  InitCommonControls

' Window-Handle erstellen fr Ballon-ToolTipStyle
  hToolTip = CreateWindowEx( _
        0, "tooltips_class32", "", 200, 0, 0, 0, 0, 0, 0, 0, 0)

' Setzen der maximalen Breite des ToolTip-Fensters in Pixel
  SendMessage hToolTip, TTM_SETMAXTIPWIDTH, 0, 300
  
  
'ToolTipp-Text zuweisen
  SetMultiLineToolTip Pic.hWnd, fktToolTipText
    
End Sub

Private Sub UserControl_Resize()
On Error GoTo Fehlerbehandlung

With Pic
    .Left = 0
    .Top = 0
    .Height = UserControl.Height
    UserControl.Width = .Height
    .Width = UserControl.Height
End With

    Call Zeitwertanzeigen

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub UserControl_Show()
On Error GoTo Fehlerbehandlung
    On Error Resume Next
    
    Select Case BorderStyle
        Case 0
            BorderStyleRaised Pic.hWnd, True
            Pic.BorderStyle = m_BorderStyle
            Mitte = Pic.Height / 2    'Die Mitte der PictureBox
        Case 1
            BorderStyleRaised Pic.hWnd, True
            Pic.BorderStyle = m_BorderStyle
            Mitte = (Pic.Height / 2) - 60    'Die Mitte der PictureBox
        Case 2
            Pic.BorderStyle = 0
            Mitte = (Pic.Height / 2) - 60    'Die Mitte der PictureBox
            BorderStyleRaised Pic.hWnd, False
        Case 3
            Pic.BorderStyle = 1
            Mitte = (Pic.Height / 2) - 75    'Die Mitte der PictureBox
            BorderStyleRaised Pic.hWnd, False
    End Select
    
    DtGr = (DotGre / 1000) * Mitte

    Call Zeitwertanzeigen

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub UserControl_Terminate()

  'ToolTip-Fenster zerstren, um den belegten Speicher im
  'System wieder freizugeben:
  DestroyWindow hToolTip
  
End Sub

Private Sub Zeitwertanzeigen()
On Error GoTo Fehlerbehandlung
    On Error Resume Next
    
    SetMultiLineToolTip Pic.hWnd, fktToolTipText
    
    Select Case m_BorderStyle
        Case 0
            Mitte = Pic.Height / 2    'Die Mitte der PictureBox
        Case 1
            Mitte = (Pic.Height / 2) - 60    'Die Mitte der PictureBox
        Case 2
            Mitte = (Pic.Height / 2) - 60    'Die Mitte der PictureBox
        Case 3
            Mitte = (Pic.Height / 2) - 75    'Die Mitte der PictureBox
    End Select
    
    With Pic
        .AutoRedraw = True
        .Cls                     'PictureBox leeren
        .DrawWidth = 1           'Breite der zu zeichnenden Punkte
        
        MakeGradient UserControl.Pic, GradientColor1, GradientColor2, 1
        
        If Enabled Then
            .ForeColor = ColorCaption
        Else
            .ForeColor = DisabledColor
        End If
        .FontSize = FontSizeCaption
        .FontBold = FontBoldCaption
        Pic.Print Caption
        
        If hasFocus Then
            If BooleanFocusRect Then
                'die FocusRect-Linien nur zeichnen wenn gewollt
                .DrawStyle = FocusDrawStyle
                .ForeColor = FocusColor
                
                Pic.Line (20, 20)-(20, .Width - 180)
                Pic.Line (20, 20)-(.Width - 180, 20)
                '.DrawWidth = 2
                Pic.Line (20, .Height - 180)-(.Width - 180, .Width - 180)
                Pic.Line (.Height - 180, 20)-(.Width - 180, .Width - 180)
            End If
        End If
            
            .DrawStyle = 0  'den Normalzustand wieder herstellen (Ausgefllt zeichnen)
            
    Dim r0 As Long
    r0 = Mitte - AbstandStricheAuen
    Dim r1 As Long
    r1 = Mitte - AbstandStricheMitte
    Dim r2 As Long
    r2 = Mitte - (.Width / AbstandStricheInnen)
    
    If Enabled Then
        'die Linien und Zahlen zeichnen
        Call NumberSheet(Pic, Mitte, Mitte, r0, r1, r2, ColorStundenStriche, ColorMinutenStriche)
    Else
        'die Linien und Zahlen zeichnen
        Call NumberSheet(Pic, Mitte, Mitte, r0, r1, r2, DisabledColor, DisabledColor)
    End If
    
    For X = 1 To 12
        X1 = Sin((180 - X / 12 * 360) / Rad) * (Mitte / AbstandDot) 'x-Position
        Y1 = Cos((180 - X / 12 * 360) / Rad) * (Mitte / AbstandDot) 'y-Position
        DrawDot X1, Y1  'die kleinen Vierecke zeichnen
    Next X
    '----------------------------------------------------------------------------------------------
        'die ersten 2 Zahlen (Stunden) extrahieren
        Stundenzahl = bStunde
    
        'die 2 Zahlen in der Mitte (Minuten) extrahieren
        WertMinuten = (bMinute / 60) * 100
        
        'die letzten 2 Zahlen (Sekunden) extrahieren
        WertSekunden = bSekunde / 60
        
        'Gesamtwert berechnen und anzeigen
        Stundenwert = Stundenzahl + (WertMinuten + WertSekunden) / 100
        EigenerTimerWert = Stundenwert * 3600
    
            Sec = bSekunde
            Min = bMinute
            Stu = EigenerTimerWert / 3600
    '----------------------------------------------------------------------------------------------
'        Sec = Right(Format(Time, "HH:MM:SS"), 2)    'Sekunden auslesen
'        Min = Mid(Format(Time, "HH:MM:SS"), 4, 2)   'Minuten auslesen
'        Stu = Timer / 3600                          'Stunden mit Timer errechnen
        
        If Stu > 12 Then Stu = Stu - 12             '12-Stundentackt
        
        Zeiger(1, 1) = Sin((180 - Sec / 60 * 360) / Rad) * LngeSekundenZeiger + Mitte   'Sekundenzeiger x-Position
        Zeiger(1, 2) = Cos((180 - Sec / 60 * 360) / Rad) * LngeSekundenZeiger + Mitte   'Sekundenzeiger y-Position
        
        'die Sekunde anzeigen
        .CurrentX = Sin((180 - Sec / 60 * 360) / Rad) * LngeSekundenZeiger + Mitte   'Sekundenzeiger x-Position
        .CurrentY = Cos((180 - Sec / 60 * 360) / Rad) * LngeSekundenZeiger + Mitte   'Sekundenzeiger y-Position
            
            .FontSize = FontSizeSekundenZiffer
            .FontBold = FontBoldSekundenZiffer
            If Enabled Then
                .ForeColor = ColorSekundenZiffer
            Else
                Pic.ForeColor = DisabledColor
            End If
            .FontItalic = FontItalicSekundenZiffer
            .FontUnderline = FontUnderlineSekundenZiffer
            
            If Sekundenzifferanzeigen Then
                If ZifferRmisch = False Then
                    Pic.Print Format(bSekunde, "00")
                Else
                    Select Case Format(bSekunde, "00")
                        Case 1
                            Pic.Print "I"
                        Case 2
                            Pic.Print "II"
                        Case 3
                            Pic.Print "III"
                        Case 4
                            Pic.Print "IV"
                        Case 5
                            Pic.Print "V"
                        Case 6
                            Pic.Print "VI"
                        Case 7
                            Pic.Print "VII"
                        Case 8
                            Pic.Print "VIII"
                        Case 9
                            Pic.Print "IX"
                        Case 10
                            Pic.Print "X"
                        Case 11
                            Pic.Print "XI"
                        Case 12
                            Pic.Print "XII"
                        Case 13
                            Pic.Print "XIII"
                        Case 14
                            Pic.Print "XIV"
                        Case 15
                            Pic.Print "XV"
                        Case 16
                            Pic.Print "XVI"
                        Case 17
                            Pic.Print "XVII"
                        Case 18
                            Pic.Print "XVIII"
                        Case 19
                            Pic.Print "XIX"
                        Case 20
                            Pic.Print "XX"
                        Case 21
                            Pic.Print "XXI"
                        Case 22
                            Pic.Print "XXII"
                        Case 23
                            Pic.Print "XXIII"
                        Case 24
                            Pic.Print "XXIV"
                        Case 25
                            Pic.Print "XXV"
                        Case 26
                            Pic.Print "XXVI"
                        Case 27
                            Pic.Print "XXVII"
                        Case 28
                            Pic.Print "XXVIII"
                        Case 29
                            Pic.Print "XXIX"
                        Case 30
                            Pic.Print "XXX"
                        Case 31
                            Pic.Print "XXXI"
                        Case 32
                            Pic.Print "XXXII"
                        Case 33
                            Pic.Print "XXXIII"
                        Case 34
                            Pic.Print "XXXIV"
                        Case 35
                            Pic.Print "XXXV"
                        Case 36
                            Pic.Print "XXXVI"
                        Case 37
                            Pic.Print "XXXVII"
                        Case 38
                            Pic.Print "XXXVIII"
                        Case 39
                            Pic.Print "XXXIX"
                        Case 40
                            Pic.Print "XL"
                        Case 41
                            Pic.Print "XLI"
                        Case 42
                            Pic.Print "XLII"
                        Case 43
                            Pic.Print "XLIII"
                        Case 44
                            Pic.Print "XLIV"
                        Case 45
                            Pic.Print "XLV"
                        Case 46
                            Pic.Print "XLVI"
                        Case 47
                            Pic.Print "XLVII"
                        Case 48
                            Pic.Print "XLVIII"
                        Case 49
                            Pic.Print "XLIX"
                        Case 50
                            Pic.Print "L"
                        Case 51
                            Pic.Print "LI"
                        Case 52
                            Pic.Print "LII"
                        Case 53
                            Pic.Print "LIII"
                        Case 54
                            Pic.Print "LIV"
                        Case 55
                            Pic.Print "LV"
                        Case 56
                            Pic.Print "LVI"
                        Case 57
                            Pic.Print "LVII"
                        Case 58
                            Pic.Print "LVIII"
                        Case 59
                            Pic.Print "LIX"
                        Case 0, 60
                            Pic.Print "LX"
                    End Select
                End If
            End If
            
            .FontSize = 8
            .FontBold = False
            .FontItalic = False
            .FontUnderline = False
        
        Zeiger(2, 1) = Sin((180 - Min / 60 * 360) / Rad) * LngeMinutenZeiger + Mitte     'Minutenzeiger x-Position
        Zeiger(2, 2) = Cos((180 - Min / 60 * 360) / Rad) * LngeMinutenZeiger + Mitte     'Minutenzeiger y-Position
        
        Zeiger(3, 1) = Sin((180 - Stu / 12 * 360) / Rad) * LngeStundenZeiger + Mitte     'Stundenzeiger x-Position
        Zeiger(3, 2) = Cos((180 - Stu / 12 * 360) / Rad) * LngeStundenZeiger + Mitte     'Stundenzeiger y-Position
    
        For X = 1 To 3
            If X = 1 Then                       'Sekundenzeiger zeichnen
                If Enabled Then
                    .ForeColor = ColorSekundenZeiger
                Else
                    .ForeColor = DisabledColor
                End If
                .DrawWidth = BorderWidthSekundenZeiger 'Breite der Zeiger
            ElseIf X = 2 Then                   'Minuten- und Stundenzeiger zeichnen
                If Enabled Then
                    .ForeColor = ColorMinutenZeiger
                Else
                    .ForeColor = DisabledColor
                End If
                .DrawWidth = BorderWidthMinutenZeiger
            ElseIf X = 3 Then
                If Enabled Then
                    .ForeColor = ColorStundenZeiger
                Else
                    .ForeColor = DisabledColor
                End If
                .DrawWidth = BorderWidthStundenZeiger
            End If
            
            Pic.Line (Mitte, Mitte)-(Zeiger(X, 1), Zeiger(X, 2))
        Next
        
        'das letzte Viereck zentrieren und anzeigen
        .DrawWidth = 2
        DrawDot 0, 0
        
        .AutoRedraw = False
    End With
    
Exit Sub
Fehlerbehandlung:
End Sub

Private Sub NumberSheet(ByRef outCtrl As Object, ByVal Left As Long, ByVal Top As Long, _
                                                                     ByVal r0 As Long, _
                                                                     ByVal r1 As Long, _
                                                                     ByVal r2 As Long, _
                                                                     ByVal cl1 As Long, _
                                                                     ByVal cl2 As Long)
    Dim pX          As Long
    Dim pY          As Long
    Dim n           As Long
    Dim Angle       As Double
    Dim r(2)        As Long

On Error GoTo Fehlerbehandlung
    On Error Resume Next
    
    r(0) = r0: r(1) = r1: r(2) = r2
    
    pX = Left
    pY = Top
    For n = 0 To 60
        Angle = Pi / 30 * n - Pi / 2
        If n Mod 5 = 0 Then
            outCtrl.DrawWidth = BorderWidthStundenStriche
            outCtrl.Line (pX + Cos(Angle) * r(0), _
                              pY + Sin(Angle) * r(0))-(pX + Cos(Angle) * r(2), _
                              pY + Sin(Angle) * r(2)), cl1
        Else
            outCtrl.DrawWidth = BorderWidthMinutenStriche
            outCtrl.Line (pX + Cos(Angle) * r(1), _
                              pY + Sin(Angle) * r(1))-(pX + Cos(Angle) * r(2), _
                              pY + Sin(Angle) * r(2)), cl2
        End If
        
        If Minutenziffernanzeigen Then
                'die Minuten in 5 Minutenabschnitten anzeigen
                outCtrl.CurrentX = _
                pX + Cos(Angle) * (Pic.Width / AbstandMinutenZiffern) - _
                outCtrl.TextWidth("B")
                
                outCtrl.CurrentY = _
                pY + Sin(Angle) * (Pic.Width / AbstandMinutenZiffern) - _
                outCtrl.TextWidth("B")
            
            If n Mod 5 = 0 Then
                If n > 0 Then
                    outCtrl.FontSize = FontSizeMinutenZiffer
                    outCtrl.FontBold = FontBoldMinutenZiffer
                    If Enabled Then
                        outCtrl.ForeColor = ColorMinutenZiffer
                    Else
                        outCtrl.ForeColor = DisabledColor
                    End If
                    If ZifferRmisch = False Then
                        outCtrl.Print CStr(n)
                    Else
                        Select Case CStr(n)
                            Case 5
                                outCtrl.Print "  V"
                            Case 10
                                outCtrl.Print "  X"
                            Case 15
                                outCtrl.Print " XV"
                            Case 20
                                outCtrl.Print " XX"
                            Case 25
                                outCtrl.Print "XXV"
                            Case 30
                                outCtrl.Print "XXX"
                            Case 35
                                outCtrl.Print "XXXV"
                            Case 40
                                outCtrl.Print " XL"
                            Case 45
                                outCtrl.Print "XLV"
                            Case 50
                                outCtrl.Print "  L"
                            Case 55
                                outCtrl.Print " LV"
                            Case 60
                                outCtrl.Print " LX"
                        End Select
                    End If
                End If
            End If
        End If
        
        If Stundenziffernanzeigen Then
                'die Stunden anzeigen
                outCtrl.CurrentX = _
                pX + Cos(Angle) * (Pic.Width / AbstandStundenZiffern) - _
                outCtrl.TextWidth("B")
                
                outCtrl.CurrentY = _
                pY + Sin(Angle) * (Pic.Width / AbstandStundenZiffern) - _
                outCtrl.TextWidth("B")
            
            If n Mod 5 = 0 Then
                If n > 0 Then
                    outCtrl.FontSize = FontSizeStundenZiffer
                    outCtrl.FontBold = FontBoldStundenZiffer
                    If Enabled Then
                        outCtrl.ForeColor = ColorStundenZiffer
                    Else
                        outCtrl.ForeColor = DisabledColor
                    End If
                    
                    If ZifferRmisch = False Then
                        If Hour(Value) < 12 Then
                            outCtrl.Print Format(CStr(n / 5), "00")
                        Else
                            outCtrl.Print CStr((n / 5) + 12)
                        End If
                    Else
                        Select Case CStr(n)
                            Case 5
                                outCtrl.Print "  I"
                            Case 10
                                outCtrl.Print " II"
                            Case 15
                                outCtrl.Print "III"
                            Case 20
                                outCtrl.Print " IV"
                            Case 25
                                outCtrl.Print "  V"
                            Case 30
                                outCtrl.Print " VI"
                            Case 35
                                outCtrl.Print "VII"
                            Case 40
                                outCtrl.Print "VIII"
                            Case 45
                                outCtrl.Print " IX"
                            Case 50
                                outCtrl.Print "  X"
                            Case 55
                                outCtrl.Print " XI"
                            Case 60
                                outCtrl.Print "XII"
                        End Select
                    End If
                End If
            End If
        End If
    Next

Exit Sub
Fehlerbehandlung:
End Sub

Private Sub DrawDot(X1, Y1)
On Error GoTo Fehlerbehandlung

    Pic.Line ((X1 + Mitte) - DtGr, _
    (Y1 + Mitte) - DtGr)-((X1 + Mitte) + DtGr, (Y1 + Mitte) - DtGr), _
    ColorDot1, B
    Pic.Line ((X1 + Mitte) - DtGr, _
    (Y1 + Mitte) - DtGr)-((X1 + Mitte) - DtGr, (Y1 + Mitte) + DtGr), _
    ColorDot1, B
    Pic.Line ((X1 + Mitte) - DtGr, _
    (Y1 + Mitte) + DtGr)-((X1 + Mitte) + DtGr, (Y1 + Mitte) + DtGr), _
    ColorDot2, B
    Pic.Line ((X1 + Mitte) + DtGr, _
    (Y1 + Mitte) - DtGr)-((X1 + Mitte) + DtGr, (Y1 + Mitte) + DtGr), _
    ColorDot2, B

Exit Sub
Fehlerbehandlung:
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Gibt einen Wert zurck, der bestimmt, ob ein Objekt auf vom Benutzer erzeugte Ereignisse reagieren kann, oder legt diesen fest."
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled

    Call Zeitwertanzeigen

    PropertyChanged "Enabled"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=Pic,Pic,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Gibt ein Font-Objekt zurck."
Attribute Font.VB_UserMemId = -512
    Set Font = Pic.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set Pic.Font = New_Font

    Call Zeitwertanzeigen

    PropertyChanged "Font"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Erzwingt ein vollstndiges Neuzeichnen eines Objekts."
    UserControl.Refresh
    Call Zeitwertanzeigen
End Sub

Private Sub Pic_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub Pic_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub Pic_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub Pic_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
    
    SetMultiLineToolTip Pic.hWnd, fktToolTipText
        
DoEvents
End Sub

Private Sub Pic_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

'Eigenschaftenwerte vom Speicher laden
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
On Error Resume Next

    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    Set Pic.Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_GradientColor1 = PropBag.ReadProperty("GradientColor1", m_def_GradientColor1)
    m_GradientColor2 = PropBag.ReadProperty("GradientColor2", m_def_GradientColor2)
    tmrUhr.Enabled = Ambient.UserMode
    m_ColorStundenZiffer = PropBag.ReadProperty("ColorStundenZiffer", m_def_ColorStundenZiffer)
    m_ColorMinutenZiffer = PropBag.ReadProperty("ColorMinutenZiffer", m_def_ColorMinutenZiffer)
    m_ColorStundenZeiger = PropBag.ReadProperty("ColorStundenZeiger", m_def_ColorStundenZeiger)
    m_ColorMinutenZeiger = PropBag.ReadProperty("ColorMinutenZeiger", m_def_ColorMinutenZeiger)
    m_ColorSekundenZeiger = PropBag.ReadProperty("ColorSekundenZeiger", m_def_ColorSekundenZeiger)
    m_ColorStundenStriche = PropBag.ReadProperty("ColorStundenStriche", m_def_ColorStundenStriche)
    m_ColorMinutenStriche = PropBag.ReadProperty("ColorMinutenStriche", m_def_ColorMinutenStriche)
    m_ColorDot1 = PropBag.ReadProperty("ColorDot1", m_def_ColorDot1)
    m_ColorDot2 = PropBag.ReadProperty("ColorDot2", m_def_ColorDot2)
    m_LngeSekundenZeiger = PropBag.ReadProperty("LngeSekundenZeiger", m_def_LngeSekundenZeiger)
    m_LngeStundenZeiger = PropBag.ReadProperty("LngeStundenZeiger", m_def_LngeStundenZeiger)
    m_LngeMinutenZeiger = PropBag.ReadProperty("LngeMinutenZeiger", m_def_LngeMinutenZeiger)
    m_ColorSekundenZiffer = PropBag.ReadProperty("ColorSekundenZiffer", m_def_ColorSekundenZiffer)
    m_FontSizeSekundenZiffer = PropBag.ReadProperty("FontSizeSekundenZiffer", m_def_FontSizeSekundenZiffer)
    m_FontBoldSekundenZiffer = PropBag.ReadProperty("FontBoldSekundenZiffer", m_def_FontBoldSekundenZiffer)
    m_FontItalicSekundenZiffer = PropBag.ReadProperty("FontItalicSekundenZiffer", m_def_FontItalicSekundenZiffer)
    m_FontUnderlineSekundenZiffer = PropBag.ReadProperty("FontUnderlineSekundenZiffer", m_def_FontUnderlineSekundenZiffer)
    m_FontSizeMinutenZiffer = PropBag.ReadProperty("FontSizeMinutenZiffer", m_def_FontSizeMinutenZiffer)
    m_FontSizeStundenZiffer = PropBag.ReadProperty("FontSizeStundenZiffer", m_def_FontSizeStundenZiffer)
    m_FontBoldStundenZiffer = PropBag.ReadProperty("FontBoldStundenZiffer", m_def_FontBoldStundenZiffer)
    m_FontBoldMinutenZiffer = PropBag.ReadProperty("FontBoldMinutenZiffer", m_def_FontBoldMinutenZiffer)
    m_bSekunde = PropBag.ReadProperty("bSekunde", m_def_bSekunde)
    m_bMinute = PropBag.ReadProperty("bMinute", m_def_bMinute)
    m_bStunde = PropBag.ReadProperty("bStunde", m_def_bStunde)
    m_Value = PropBag.ReadProperty("Value", m_def_Value)
    m_Sekundenzifferanzeigen = PropBag.ReadProperty("Sekundenzifferanzeigen", m_def_Sekundenzifferanzeigen)
    m_Minutenziffernanzeigen = PropBag.ReadProperty("Minutenziffernanzeigen", m_def_Minutenziffernanzeigen)
    m_Stundenziffernanzeigen = PropBag.ReadProperty("Stundenziffernanzeigen", m_def_Stundenziffernanzeigen)
    tmrUhr.Interval = PropBag.ReadProperty("Interval", 0)
    m_AbstandMinutenZiffern = PropBag.ReadProperty("AbstandMinutenZiffern", m_def_AbstandMinutenZiffern)
    m_AbstandStundenZiffern = PropBag.ReadProperty("AbstandStundenZiffern", m_def_AbstandStundenZiffern)
    m_AbstandStricheInnen = PropBag.ReadProperty("AbstandStricheInnen", m_def_AbstandStricheInnen)
    m_AbstandStricheAuen = PropBag.ReadProperty("AbstandStricheAuen", m_def_AbstandStricheAuen)
    m_BorderWidthStundenStriche = PropBag.ReadProperty("BorderWidthStundenStriche", m_def_BorderWidthStundenStriche)
    m_BorderWidthMinutenStriche = PropBag.ReadProperty("BorderWidthMinutenStriche", m_def_BorderWidthMinutenStriche)
    m_BorderWidthSekundenZeiger = PropBag.ReadProperty("BorderWidthSekundenZeiger", m_def_BorderWidthSekundenZeiger)
    m_BorderWidthMinutenZeiger = PropBag.ReadProperty("BorderWidthMinutenZeiger", m_def_BorderWidthMinutenZeiger)
    m_BorderWidthStundenZeiger = PropBag.ReadProperty("BorderWidthStundenZeiger", m_def_BorderWidthStundenZeiger)
    m_DotGre = PropBag.ReadProperty("DotGre", m_def_DotGre)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    m_FontSizeCaption = PropBag.ReadProperty("FontSizeCaption", m_def_FontSizeCaption)
    m_FontBoldCaption = PropBag.ReadProperty("FontBoldCaption", m_def_FontBoldCaption)
    m_ColorCaption = PropBag.ReadProperty("ColorCaption", m_def_ColorCaption)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    UserControl.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    m_AbstandDot = PropBag.ReadProperty("AbstandDot", m_def_AbstandDot)
    m_MultiLineToolTipText = PropBag.ReadProperty("MultiLineToolTipText", m_def_MultiLineToolTipText)
    m_DisabledColor = PropBag.ReadProperty("DisabledColor", m_def_DisabledColor)
    m_FocusColor = PropBag.ReadProperty("FocusColor", m_def_FocusColor)
    m_FocusDrawStyle = PropBag.ReadProperty("FocusDrawStyle", m_def_FocusDrawStyle)
    m_BooleanFocusRect = PropBag.ReadProperty("BooleanFocusRect", m_def_BooleanFocusRect)
    m_ZifferRmisch = PropBag.ReadProperty("ZifferRmisch", m_def_ZifferRmisch)
    
    m_AbstandStricheMitte = PropBag.ReadProperty("AbstandStricheMitte", m_def_AbstandStricheMitte)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
    
    Select Case m_BorderStyle
        Case 0
            BorderStyleRaised Pic.hWnd, True
            Pic.BorderStyle = m_BorderStyle
            Mitte = Pic.Height / 2    'Die Mitte der PictureBox
        Case 1
            BorderStyleRaised Pic.hWnd, True
            Pic.BorderStyle = m_BorderStyle
            Mitte = (Pic.Height / 2) - 60    'Die Mitte der PictureBox
        Case 2
            Pic.BorderStyle = 0
            Mitte = (Pic.Height / 2) - 60    'Die Mitte der PictureBox
            BorderStyleRaised Pic.hWnd, False
        Case 3
            Pic.BorderStyle = 1
            Mitte = (Pic.Height / 2) - 75    'Die Mitte der PictureBox
            BorderStyleRaised Pic.hWnd, False
    End Select
End Sub

'Eigenschaftenwerte in den Speicher schreiben
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
On Error Resume Next

    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Font", Pic.Font, Ambient.Font)
    Call PropBag.WriteProperty("GradientColor1", m_GradientColor1, m_def_GradientColor1)
    Call PropBag.WriteProperty("GradientColor2", m_GradientColor2, m_def_GradientColor2)
    Call PropBag.WriteProperty("ColorStundenZiffer", m_ColorStundenZiffer, m_def_ColorStundenZiffer)
    Call PropBag.WriteProperty("ColorMinutenZiffer", m_ColorMinutenZiffer, m_def_ColorMinutenZiffer)
    Call PropBag.WriteProperty("ColorStundenZeiger", m_ColorStundenZeiger, m_def_ColorStundenZeiger)
    Call PropBag.WriteProperty("ColorMinutenZeiger", m_ColorMinutenZeiger, m_def_ColorMinutenZeiger)
    Call PropBag.WriteProperty("ColorSekundenZeiger", m_ColorSekundenZeiger, m_def_ColorSekundenZeiger)
    Call PropBag.WriteProperty("ColorStundenStriche", m_ColorStundenStriche, m_def_ColorStundenStriche)
    Call PropBag.WriteProperty("ColorMinutenStriche", m_ColorMinutenStriche, m_def_ColorMinutenStriche)
    Call PropBag.WriteProperty("ColorDot1", m_ColorDot1, m_def_ColorDot1)
    Call PropBag.WriteProperty("ColorDot2", m_ColorDot2, m_def_ColorDot2)
    Call PropBag.WriteProperty("LngeSekundenZeiger", m_LngeSekundenZeiger, m_def_LngeSekundenZeiger)
    Call PropBag.WriteProperty("LngeStundenZeiger", m_LngeStundenZeiger, m_def_LngeStundenZeiger)
    Call PropBag.WriteProperty("LngeMinutenZeiger", m_LngeMinutenZeiger, m_def_LngeMinutenZeiger)
    Call PropBag.WriteProperty("ColorSekundenZiffer", m_ColorSekundenZiffer, m_def_ColorSekundenZiffer)
    Call PropBag.WriteProperty("FontSizeSekundenZiffer", m_FontSizeSekundenZiffer, m_def_FontSizeSekundenZiffer)
    Call PropBag.WriteProperty("FontBoldSekundenZiffer", m_FontBoldSekundenZiffer, m_def_FontBoldSekundenZiffer)
    Call PropBag.WriteProperty("FontItalicSekundenZiffer", m_FontItalicSekundenZiffer, m_def_FontItalicSekundenZiffer)
    Call PropBag.WriteProperty("FontUnderlineSekundenZiffer", m_FontUnderlineSekundenZiffer, m_def_FontUnderlineSekundenZiffer)
    Call PropBag.WriteProperty("FontSizeMinutenZiffer", m_FontSizeMinutenZiffer, m_def_FontSizeMinutenZiffer)
    Call PropBag.WriteProperty("FontSizeStundenZiffer", m_FontSizeStundenZiffer, m_def_FontSizeStundenZiffer)
    Call PropBag.WriteProperty("FontBoldStundenZiffer", m_FontBoldStundenZiffer, m_def_FontBoldStundenZiffer)
    Call PropBag.WriteProperty("FontBoldMinutenZiffer", m_FontBoldMinutenZiffer, m_def_FontBoldMinutenZiffer)
    Call PropBag.WriteProperty("bSekunde", m_bSekunde, m_def_bSekunde)
    Call PropBag.WriteProperty("bMinute", m_bMinute, m_def_bMinute)
    Call PropBag.WriteProperty("bStunde", m_bStunde, m_def_bStunde)
    Call PropBag.WriteProperty("Value", m_Value, m_def_Value)
    Call PropBag.WriteProperty("Sekundenzifferanzeigen", m_Sekundenzifferanzeigen, m_def_Sekundenzifferanzeigen)
    Call PropBag.WriteProperty("Minutenziffernanzeigen", m_Minutenziffernanzeigen, m_def_Minutenziffernanzeigen)
    Call PropBag.WriteProperty("Stundenziffernanzeigen", m_Stundenziffernanzeigen, m_def_Stundenziffernanzeigen)
    Call PropBag.WriteProperty("Interval", tmrUhr.Interval, 0)
    Call PropBag.WriteProperty("AbstandMinutenZiffern", m_AbstandMinutenZiffern, m_def_AbstandMinutenZiffern)
    Call PropBag.WriteProperty("AbstandStundenZiffern", m_AbstandStundenZiffern, m_def_AbstandStundenZiffern)
    Call PropBag.WriteProperty("AbstandStricheInnen", m_AbstandStricheInnen, m_def_AbstandStricheInnen)
    Call PropBag.WriteProperty("AbstandStricheAuen", m_AbstandStricheAuen, m_def_AbstandStricheAuen)
    Call PropBag.WriteProperty("BorderWidthStundenStriche", m_BorderWidthStundenStriche, m_def_BorderWidthStundenStriche)
    Call PropBag.WriteProperty("BorderWidthMinutenStriche", m_BorderWidthMinutenStriche, m_def_BorderWidthMinutenStriche)
    Call PropBag.WriteProperty("BorderWidthSekundenZeiger", m_BorderWidthSekundenZeiger, m_def_BorderWidthSekundenZeiger)
    Call PropBag.WriteProperty("BorderWidthMinutenZeiger", m_BorderWidthMinutenZeiger, m_def_BorderWidthMinutenZeiger)
    Call PropBag.WriteProperty("BorderWidthStundenZeiger", m_BorderWidthStundenZeiger, m_def_BorderWidthStundenZeiger)
    Call PropBag.WriteProperty("DotGre", m_DotGre, m_def_DotGre)
    Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
    Call PropBag.WriteProperty("FontSizeCaption", m_FontSizeCaption, m_def_FontSizeCaption)
    Call PropBag.WriteProperty("FontBoldCaption", m_FontBoldCaption, m_def_FontBoldCaption)
    Call PropBag.WriteProperty("ColorCaption", m_ColorCaption, m_def_ColorCaption)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, 0)
    Call PropBag.WriteProperty("AbstandDot", m_AbstandDot, m_def_AbstandDot)
    Call PropBag.WriteProperty("MultiLineToolTipText", m_MultiLineToolTipText, m_def_MultiLineToolTipText)
    Call PropBag.WriteProperty("DisabledColor", m_DisabledColor, m_def_DisabledColor)
    Call PropBag.WriteProperty("FocusColor", m_FocusColor, m_def_FocusColor)
    Call PropBag.WriteProperty("FocusDrawStyle", m_FocusDrawStyle, m_def_FocusDrawStyle)
    Call PropBag.WriteProperty("BooleanFocusRect", m_BooleanFocusRect, m_def_BooleanFocusRect)
    Call PropBag.WriteProperty("ZifferRmisch", m_ZifferRmisch, m_def_ZifferRmisch)
    Call PropBag.WriteProperty("AbstandStricheMitte", m_AbstandStricheMitte, m_def_AbstandStricheMitte)
    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,&H00C0C0C0&
Public Property Get GradientColor1() As OLE_COLOR
Attribute GradientColor1.VB_Description = "gibt die 1. Gradientfarbe zurck oder legt sie fest"
    GradientColor1 = m_GradientColor1
End Property

Public Property Let GradientColor1(ByVal New_GradientColor1 As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_GradientColor1 = New_GradientColor1

    Call Zeitwertanzeigen

    PropertyChanged "GradientColor1"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,&H00FFFFFF&
Public Property Get GradientColor2() As OLE_COLOR
Attribute GradientColor2.VB_Description = "gibt die 2. Gradientfarbe zurck oder legt sie fest"
    GradientColor2 = m_GradientColor2
End Property

Public Property Let GradientColor2(ByVal New_GradientColor2 As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_GradientColor2 = New_GradientColor2

    Call Zeitwertanzeigen

    PropertyChanged "GradientColor2"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'Eigenschaften fr Benutzersteuerelement initialisieren
Private Sub UserControl_InitProperties()
    m_GradientColor1 = m_def_GradientColor1
    m_GradientColor2 = m_def_GradientColor2
    m_ColorStundenZiffer = m_def_ColorStundenZiffer
    m_ColorMinutenZiffer = m_def_ColorMinutenZiffer
    m_ColorStundenZeiger = m_def_ColorStundenZeiger
    m_ColorMinutenZeiger = m_def_ColorMinutenZeiger
    m_ColorSekundenZeiger = m_def_ColorSekundenZeiger
    m_ColorStundenStriche = m_def_ColorStundenStriche
    m_ColorMinutenStriche = m_def_ColorMinutenStriche
    m_ColorDot1 = m_def_ColorDot1
    m_ColorDot2 = m_def_ColorDot2
    m_LngeSekundenZeiger = m_def_LngeSekundenZeiger
    m_LngeStundenZeiger = m_def_LngeStundenZeiger
    m_LngeMinutenZeiger = m_def_LngeMinutenZeiger
    m_ColorSekundenZiffer = m_def_ColorSekundenZiffer
    m_FontSizeSekundenZiffer = m_def_FontSizeSekundenZiffer
    m_FontBoldSekundenZiffer = m_def_FontBoldSekundenZiffer
    m_FontItalicSekundenZiffer = m_def_FontItalicSekundenZiffer
    m_FontUnderlineSekundenZiffer = m_def_FontUnderlineSekundenZiffer
    m_FontSizeMinutenZiffer = m_def_FontSizeMinutenZiffer
    m_FontSizeStundenZiffer = m_def_FontSizeStundenZiffer
    m_FontBoldStundenZiffer = m_def_FontBoldStundenZiffer
    m_FontBoldMinutenZiffer = m_def_FontBoldMinutenZiffer
    m_bSekunde = m_def_bSekunde
    m_bMinute = m_def_bMinute
    m_bStunde = m_def_bStunde
    m_Value = m_def_Value
    m_Sekundenzifferanzeigen = m_def_Sekundenzifferanzeigen
    m_Minutenziffernanzeigen = m_def_Minutenziffernanzeigen
    m_Stundenziffernanzeigen = m_def_Stundenziffernanzeigen
    m_AbstandMinutenZiffern = m_def_AbstandMinutenZiffern
    m_AbstandStundenZiffern = m_def_AbstandStundenZiffern
    m_AbstandStricheInnen = m_def_AbstandStricheInnen
    m_AbstandStricheAuen = m_def_AbstandStricheAuen
    m_BorderWidthStundenStriche = m_def_BorderWidthStundenStriche
    m_BorderWidthMinutenStriche = m_def_BorderWidthMinutenStriche
    m_BorderWidthSekundenZeiger = m_def_BorderWidthSekundenZeiger
    m_BorderWidthMinutenZeiger = m_def_BorderWidthMinutenZeiger
    m_BorderWidthStundenZeiger = m_def_BorderWidthStundenZeiger
    m_DotGre = m_def_DotGre
    m_Caption = m_def_Caption
    m_FontSizeCaption = m_def_FontSizeCaption
    m_FontBoldCaption = m_def_FontBoldCaption
    m_ColorCaption = m_def_ColorCaption
    m_AbstandDot = m_def_AbstandDot
    m_MultiLineToolTipText = m_def_MultiLineToolTipText
    m_DisabledColor = m_def_DisabledColor
    m_FocusColor = m_def_FocusColor
    m_FocusDrawStyle = m_def_FocusDrawStyle
    m_BooleanFocusRect = m_def_BooleanFocusRect
    m_ZifferRmisch = m_def_ZifferRmisch
    m_AbstandStricheMitte = m_def_AbstandStricheMitte
    m_BorderStyle = m_def_BorderStyle
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbblack
Public Property Get ColorStundenZiffer() As OLE_COLOR
Attribute ColorStundenZiffer.VB_Description = "gibt die Farbe der Stundenziffern zurck oder legt sie fest"
    ColorStundenZiffer = m_ColorStundenZiffer
End Property

Public Property Let ColorStundenZiffer(ByVal New_ColorStundenZiffer As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_ColorStundenZiffer = New_ColorStundenZiffer

    Call Zeitwertanzeigen

    PropertyChanged "ColorStundenZiffer"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbmagenta
Public Property Get ColorMinutenZiffer() As OLE_COLOR
Attribute ColorMinutenZiffer.VB_Description = "gibt die Farbe der Minutenziffern zurck oder legt sie fest"
    ColorMinutenZiffer = m_ColorMinutenZiffer
End Property

Public Property Let ColorMinutenZiffer(ByVal New_ColorMinutenZiffer As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_ColorMinutenZiffer = New_ColorMinutenZiffer

    Call Zeitwertanzeigen

    PropertyChanged "ColorMinutenZiffer"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbblack
Public Property Get ColorStundenZeiger() As OLE_COLOR
Attribute ColorStundenZeiger.VB_Description = "gibt die Farbe des Stundenzeigers zurck oder legt sie fest"
    ColorStundenZeiger = m_ColorStundenZeiger
End Property

Public Property Let ColorStundenZeiger(ByVal New_ColorStundenZeiger As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_ColorStundenZeiger = New_ColorStundenZeiger

    Call Zeitwertanzeigen

    PropertyChanged "ColorStundenZeiger"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbblue
Public Property Get ColorMinutenZeiger() As OLE_COLOR
Attribute ColorMinutenZeiger.VB_Description = "gibt die Farbe des Minutenzeigers zurck oder legt sie fest"
    ColorMinutenZeiger = m_ColorMinutenZeiger
End Property

Public Property Let ColorMinutenZeiger(ByVal New_ColorMinutenZeiger As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_ColorMinutenZeiger = New_ColorMinutenZeiger

    Call Zeitwertanzeigen

    PropertyChanged "ColorMinutenZeiger"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbred
Public Property Get ColorSekundenZeiger() As OLE_COLOR
Attribute ColorSekundenZeiger.VB_Description = "gibt die Farbe des Sekundenzeigers zurck oder legt sie fest"
    ColorSekundenZeiger = m_ColorSekundenZeiger
End Property

Public Property Let ColorSekundenZeiger(ByVal New_ColorSekundenZeiger As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_ColorSekundenZeiger = New_ColorSekundenZeiger

    Call Zeitwertanzeigen

    PropertyChanged "ColorSekundenZeiger"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbblue
Public Property Get ColorStundenStriche() As OLE_COLOR
Attribute ColorStundenStriche.VB_Description = "gibt die Farbe der Stundenstriche zurck oder legt sie fest"
    ColorStundenStriche = m_ColorStundenStriche
End Property

Public Property Let ColorStundenStriche(ByVal New_ColorStundenStriche As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_ColorStundenStriche = New_ColorStundenStriche

    Call Zeitwertanzeigen

    PropertyChanged "ColorStundenStriche"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbmagenta
Public Property Get ColorMinutenStriche() As OLE_COLOR
Attribute ColorMinutenStriche.VB_Description = "gibt die Farbe der Minutenstriche zurck oder legt sie fest"
    ColorMinutenStriche = m_ColorMinutenStriche
End Property

Public Property Let ColorMinutenStriche(ByVal New_ColorMinutenStriche As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_ColorMinutenStriche = New_ColorMinutenStriche

    Call Zeitwertanzeigen

    PropertyChanged "ColorMinutenStriche"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,&HE0E0E0
Public Property Get ColorDot1() As OLE_COLOR
Attribute ColorDot1.VB_Description = "gibt die 1. Farbe des Dot-Vierecks zurck oder legt sie fest"
    ColorDot1 = m_ColorDot1
End Property

Public Property Let ColorDot1(ByVal New_ColorDot1 As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_ColorDot1 = New_ColorDot1

    Call Zeitwertanzeigen

    PropertyChanged "ColorDot1"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,&H808080
Public Property Get ColorDot2() As OLE_COLOR
Attribute ColorDot2.VB_Description = "gibt die 2. Farbe des Dot-Vierecks zurck oder legt sie fest"
    ColorDot2 = m_ColorDot2
End Property

Public Property Let ColorDot2(ByVal New_ColorDot2 As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_ColorDot2 = New_ColorDot2

    Call Zeitwertanzeigen

    PropertyChanged "ColorDot2"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,800
Public Property Get LngeSekundenZeiger() As Long
Attribute LngeSekundenZeiger.VB_Description = "gibt die Lnge des Sekundenzeigers zurck oder legt sie fest"
    LngeSekundenZeiger = m_LngeSekundenZeiger
End Property

Public Property Let LngeSekundenZeiger(ByVal New_LngeSekundenZeiger As Long)
On Error GoTo Fehlerbehandlung

    m_LngeSekundenZeiger = New_LngeSekundenZeiger

    Call Zeitwertanzeigen

    PropertyChanged "LngeSekundenZeiger"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,600
Public Property Get LngeStundenZeiger() As Long
Attribute LngeStundenZeiger.VB_Description = "gibt die Lnge des Stundenzeigers zurck oder legt sie fest"
    LngeStundenZeiger = m_LngeStundenZeiger
End Property

Public Property Let LngeStundenZeiger(ByVal New_LngeStundenZeiger As Long)
On Error GoTo Fehlerbehandlung

    m_LngeStundenZeiger = New_LngeStundenZeiger

    Call Zeitwertanzeigen

    PropertyChanged "LngeStundenZeiger"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,1200
Public Property Get LngeMinutenZeiger() As Long
Attribute LngeMinutenZeiger.VB_Description = "gibt die Lnge des Minutenzeigers zurck oder legt sie fest"
    LngeMinutenZeiger = m_LngeMinutenZeiger
End Property

Public Property Let LngeMinutenZeiger(ByVal New_LngeMinutenZeiger As Long)
On Error GoTo Fehlerbehandlung

    m_LngeMinutenZeiger = New_LngeMinutenZeiger

    Call Zeitwertanzeigen

    PropertyChanged "LngeMinutenZeiger"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbblack
Public Property Get ColorSekundenZiffer() As OLE_COLOR
Attribute ColorSekundenZiffer.VB_Description = "gibt die Farbe der Sekundenziffer zurck oder legt sie fest"
    ColorSekundenZiffer = m_ColorSekundenZiffer
End Property

Public Property Let ColorSekundenZiffer(ByVal New_ColorSekundenZiffer As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_ColorSekundenZiffer = New_ColorSekundenZiffer

    Call Zeitwertanzeigen

    PropertyChanged "ColorSekundenZiffer"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,14
Public Property Get FontSizeSekundenZiffer() As Long
Attribute FontSizeSekundenZiffer.VB_Description = "gibt die Schriftgre der Sekundenziffer zurck oder legt sie fest"
    FontSizeSekundenZiffer = m_FontSizeSekundenZiffer
End Property

Public Property Let FontSizeSekundenZiffer(ByVal New_FontSizeSekundenZiffer As Long)
On Error GoTo Fehlerbehandlung

    m_FontSizeSekundenZiffer = New_FontSizeSekundenZiffer
    If m_FontSizeSekundenZiffer < 8 Then
        m_FontSizeSekundenZiffer = 8
    End If

    Call Zeitwertanzeigen

    PropertyChanged "FontSizeSekundenZiffer"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,true
Public Property Get FontBoldSekundenZiffer() As Boolean
Attribute FontBoldSekundenZiffer.VB_Description = "gibt die FontBold-Eigenschaft der Sekundenziffer zurck oder legt sie fest"
    FontBoldSekundenZiffer = m_FontBoldSekundenZiffer
End Property

Public Property Let FontBoldSekundenZiffer(ByVal New_FontBoldSekundenZiffer As Boolean)
    m_FontBoldSekundenZiffer = New_FontBoldSekundenZiffer

    Call Zeitwertanzeigen

    PropertyChanged "FontBoldSekundenZiffer"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,true
Public Property Get FontItalicSekundenZiffer() As Boolean
Attribute FontItalicSekundenZiffer.VB_Description = "gibt die FontItalic-Eigenschaft der Sekundenziffer zurck oder legt sie fest"
    FontItalicSekundenZiffer = m_FontItalicSekundenZiffer
End Property

Public Property Let FontItalicSekundenZiffer(ByVal New_FontItalicSekundenZiffer As Boolean)
    m_FontItalicSekundenZiffer = New_FontItalicSekundenZiffer

    Call Zeitwertanzeigen

    PropertyChanged "FontItalicSekundenZiffer"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,true
Public Property Get FontUnderlineSekundenZiffer() As Boolean
Attribute FontUnderlineSekundenZiffer.VB_Description = "gibt die FontUnderline-Eigenschaft der Sekundenziffer zurck oder legt sie fest"
    FontUnderlineSekundenZiffer = m_FontUnderlineSekundenZiffer
End Property

Public Property Let FontUnderlineSekundenZiffer(ByVal New_FontUnderlineSekundenZiffer As Boolean)
    m_FontUnderlineSekundenZiffer = New_FontUnderlineSekundenZiffer

    Call Zeitwertanzeigen

    PropertyChanged "FontUnderlineSekundenZiffer"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,8
Public Property Get FontSizeMinutenZiffer() As Long
Attribute FontSizeMinutenZiffer.VB_Description = "gibt die FontSize-Eigenschaft der Minutenziffern zurck oder legt sie fest"
    FontSizeMinutenZiffer = m_FontSizeMinutenZiffer
End Property

Public Property Let FontSizeMinutenZiffer(ByVal New_FontSizeMinutenZiffer As Long)
On Error GoTo Fehlerbehandlung

    m_FontSizeMinutenZiffer = New_FontSizeMinutenZiffer
    If m_FontSizeMinutenZiffer < 8 Then
        m_FontSizeMinutenZiffer = 8
    End If

    Call Zeitwertanzeigen

    PropertyChanged "FontSizeMinutenZiffer"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,8
Public Property Get FontSizeStundenZiffer() As Long
Attribute FontSizeStundenZiffer.VB_Description = "gibt die FontSize-Eigenschaft der Stundenziffern zurck oder legt sie fest"
    FontSizeStundenZiffer = m_FontSizeStundenZiffer
End Property

Public Property Let FontSizeStundenZiffer(ByVal New_FontSizeStundenZiffer As Long)
On Error GoTo Fehlerbehandlung

    m_FontSizeStundenZiffer = New_FontSizeStundenZiffer
    If m_FontSizeStundenZiffer < 8 Then
        m_FontSizeStundenZiffer = 8
    End If

    Call Zeitwertanzeigen

    PropertyChanged "FontSizeStundenZiffer"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,false
Public Property Get FontBoldStundenZiffer() As Boolean
Attribute FontBoldStundenZiffer.VB_Description = "gibt die FontBold-Eigenschaft der Stundenziffern zurck oder legt sie fest"
    FontBoldStundenZiffer = m_FontBoldStundenZiffer
End Property

Public Property Let FontBoldStundenZiffer(ByVal New_FontBoldStundenZiffer As Boolean)
    m_FontBoldStundenZiffer = New_FontBoldStundenZiffer

    Call Zeitwertanzeigen

    PropertyChanged "FontBoldStundenZiffer"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,false
Public Property Get FontBoldMinutenZiffer() As Boolean
Attribute FontBoldMinutenZiffer.VB_Description = "gibt die FontBold-Eigenschaft der Minutenziffern zurck oder legt sie fest"
    FontBoldMinutenZiffer = m_FontBoldMinutenZiffer
End Property

Public Property Let FontBoldMinutenZiffer(ByVal New_FontBoldMinutenZiffer As Boolean)
    m_FontBoldMinutenZiffer = New_FontBoldMinutenZiffer

    Call Zeitwertanzeigen

    PropertyChanged "FontBoldMinutenZiffer"
End Property


'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=1,0,0,00
Public Property Get bStunde() As Long
On Error GoTo Fehlerbehandlung
    bStunde = Format(m_bStunde, "00")
Exit Property
Fehlerbehandlung:
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=1,0,0,00
Public Property Get bMinute() As Long
On Error GoTo Fehlerbehandlung
    bMinute = Format(m_bMinute, "00")
Exit Property
Fehlerbehandlung:
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=1,0,0,00
Public Property Get bSekunde() As Long
On Error GoTo Fehlerbehandlung
    bSekunde = Format(m_bSekunde, "00")
Exit Property
Fehlerbehandlung:
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=13,0,0,"00:00:00"
Public Property Get Value() As String
Attribute Value.VB_Description = "gibt den Anzeigewert zurck oder legt ihn fest"
    Value = Format(bStunde, "00") & ":" & Format(bMinute, "00") & ":" & Format(bSekunde, "00")
End Property

Public Property Let Value(ByVal New_Value As String)
On Error GoTo Fehlerbehandlung
    m_Value = Format(New_Value, "hh:mm:ss")
    PropertyChanged "Value"
        'die ersten 2 Zahlen (Stunden) extrahieren
        m_bStunde = Left(New_Value, 2)
        'die 2 Zahlen in der Mitte (Minuten) extrahieren
        m_bMinute = Mid(New_Value, 4, 2)
        'die letzten 2 Zahlen (Sekunden) extrahieren
        m_bSekunde = Right(New_Value, 2)

    Call Zeitwertanzeigen

    RaiseEvent Change
Exit Property
Fehlerbehandlung:
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,true
Public Property Get Sekundenzifferanzeigen() As Boolean
Attribute Sekundenzifferanzeigen.VB_Description = "gibt das Anzeigeverhalten der Sekundenziffer zurck oder legt es fest"
    Sekundenzifferanzeigen = m_Sekundenzifferanzeigen
End Property

Public Property Let Sekundenzifferanzeigen(ByVal New_Sekundenzifferanzeigen As Boolean)
    m_Sekundenzifferanzeigen = New_Sekundenzifferanzeigen

    Call Zeitwertanzeigen

    PropertyChanged "Sekundenzifferanzeigen"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,true
Public Property Get Minutenziffernanzeigen() As Boolean
Attribute Minutenziffernanzeigen.VB_Description = "gibt das Anzeigeverhalten der Minutenziffern zurck oder legt es fest"
    Minutenziffernanzeigen = m_Minutenziffernanzeigen
End Property

Public Property Let Minutenziffernanzeigen(ByVal New_Minutenziffernanzeigen As Boolean)
    m_Minutenziffernanzeigen = New_Minutenziffernanzeigen

    Call Zeitwertanzeigen

    PropertyChanged "Minutenziffernanzeigen"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,true
Public Property Get Stundenziffernanzeigen() As Boolean
Attribute Stundenziffernanzeigen.VB_Description = "gibt das Anzeigeverhalten der Stundenziffern zurck oder legt es fest"
    Stundenziffernanzeigen = m_Stundenziffernanzeigen
End Property

Public Property Let Stundenziffernanzeigen(ByVal New_Stundenziffernanzeigen As Boolean)
    m_Stundenziffernanzeigen = New_Stundenziffernanzeigen

    Call Zeitwertanzeigen

    PropertyChanged "Stundenziffernanzeigen"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=tmrUhr,tmrUhr,-1,Interval
Public Property Get Interval() As Long
Attribute Interval.VB_Description = "Gibt die Anzahl der Millisekunden zwischen Aufrufen an das Timer-Ereignis eines Zeitgeber-Steuerelements zurck oder legt diese fest."
    Interval = tmrUhr.Interval
End Property

Public Property Let Interval(ByVal New_Interval As Long)
On Error GoTo Fehlerbehandlung

    tmrUhr.Interval() = New_Interval
    PropertyChanged "Interval"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

Private Sub tmrUhr_Timer()
If Enabled Then
    RaiseEvent Timer
End If
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=2,0,0,4
Public Property Get AbstandMinutenZiffern() As Currency
Attribute AbstandMinutenZiffern.VB_Description = "gibt den Abstand der Minutenziffern zurck oder legt ihn fest"
    AbstandMinutenZiffern = m_AbstandMinutenZiffern
End Property

Public Property Let AbstandMinutenZiffern(ByVal New_AbstandMinutenZiffern As Currency)
On Error GoTo Fehlerbehandlung
    
    m_AbstandMinutenZiffern = New_AbstandMinutenZiffern
    PropertyChanged "AbstandMinutenZiffern"

    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=2,0,0,2.25
Public Property Get AbstandStundenZiffern() As Currency
Attribute AbstandStundenZiffern.VB_Description = "gibt den Abstand der Stundenziffern zurck oder legt ihn fest"
    AbstandStundenZiffern = m_AbstandStundenZiffern
End Property

Public Property Let AbstandStundenZiffern(ByVal New_AbstandStundenZiffern As Currency)
On Error GoTo Fehlerbehandlung
    
    m_AbstandStundenZiffern = New_AbstandStundenZiffern
    PropertyChanged "AbstandStundenZiffern"

    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=2,0,0,7
Public Property Get AbstandStricheInnen() As Currency
Attribute AbstandStricheInnen.VB_Description = "gibt den inneren Abstand der Striche zum Rand zurck oder legt ihn fest"
    AbstandStricheInnen = m_AbstandStricheInnen
End Property

Public Property Let AbstandStricheInnen(ByVal New_AbstandStricheInnen As Currency)
On Error GoTo Fehlerbehandlung
    
    m_AbstandStricheInnen = New_AbstandStricheInnen
    PropertyChanged "AbstandStricheInnen"

    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,330
Public Property Get AbstandStricheAuen() As Long
Attribute AbstandStricheAuen.VB_Description = "gibt den ueren Abstand der Striche zum Rand zurck oder legt ihn fest"
    AbstandStricheAuen = m_AbstandStricheAuen
End Property

Public Property Let AbstandStricheAuen(ByVal New_AbstandStricheAuen As Long)
On Error GoTo Fehlerbehandlung
    
    m_AbstandStricheAuen = New_AbstandStricheAuen
    PropertyChanged "AbstandStricheAuen"

    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=1,0,0,2
Public Property Get BorderWidthStundenStriche() As Byte
Attribute BorderWidthStundenStriche.VB_Description = "gibt die Breite der Stundenstriche zurck oder legt sie fest"
    BorderWidthStundenStriche = m_BorderWidthStundenStriche
End Property

Public Property Let BorderWidthStundenStriche(ByVal New_BorderWidthStundenStriche As Byte)
On Error GoTo Fehlerbehandlung
    
    m_BorderWidthStundenStriche = New_BorderWidthStundenStriche
    PropertyChanged "BorderWidthStundenStriche"

    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=1,0,0,1
Public Property Get BorderWidthMinutenStriche() As Byte
Attribute BorderWidthMinutenStriche.VB_Description = "gibt die Breite der Minutenstriche zurck oder legt sie fest"
    BorderWidthMinutenStriche = m_BorderWidthMinutenStriche
End Property

Public Property Let BorderWidthMinutenStriche(ByVal New_BorderWidthMinutenStriche As Byte)
On Error GoTo Fehlerbehandlung
    
    m_BorderWidthMinutenStriche = New_BorderWidthMinutenStriche
    PropertyChanged "BorderWidthMinutenStriche"

    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=1,0,0,1
Public Property Get BorderWidthSekundenZeiger() As Byte
Attribute BorderWidthSekundenZeiger.VB_Description = "gibt die Breite des Sekundenzeigers zurck oder legt sie fest"
    BorderWidthSekundenZeiger = m_BorderWidthSekundenZeiger
End Property

Public Property Let BorderWidthSekundenZeiger(ByVal New_BorderWidthSekundenZeiger As Byte)
On Error GoTo Fehlerbehandlung
    
    m_BorderWidthSekundenZeiger = New_BorderWidthSekundenZeiger
    PropertyChanged "BorderWidthSekundenZeiger"

    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=1,0,0,2
Public Property Get BorderWidthMinutenZeiger() As Byte
Attribute BorderWidthMinutenZeiger.VB_Description = "gibt die Breite des Minutenzeigers zurck oder legt sie fest"
    BorderWidthMinutenZeiger = m_BorderWidthMinutenZeiger
End Property

Public Property Let BorderWidthMinutenZeiger(ByVal New_BorderWidthMinutenZeiger As Byte)
On Error GoTo Fehlerbehandlung
    
    m_BorderWidthMinutenZeiger = New_BorderWidthMinutenZeiger
    PropertyChanged "BorderWidthMinutenZeiger"

    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=1,0,0,3
Public Property Get BorderWidthStundenZeiger() As Byte
Attribute BorderWidthStundenZeiger.VB_Description = "gibt die Breite des Stundenzeigers zurck oder legt sie fest"
    BorderWidthStundenZeiger = m_BorderWidthStundenZeiger
End Property

Public Property Let BorderWidthStundenZeiger(ByVal New_BorderWidthStundenZeiger As Byte)
On Error GoTo Fehlerbehandlung
    
    m_BorderWidthStundenZeiger = New_BorderWidthStundenZeiger
    PropertyChanged "BorderWidthStundenZeiger"

    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=1,0,0,30
Public Property Get DotGre() As Byte
Attribute DotGre.VB_Description = "gibt die DotGre (Viereckgre) zurck oder legt sie fest"
    DotGre = m_DotGre
End Property

Public Property Let DotGre(ByVal New_DotGre As Byte)
On Error GoTo Fehlerbehandlung
    
    m_DotGre = New_DotGre
    PropertyChanged "DotGre"

    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=13,0,0,
Public Property Get Caption() As String
Attribute Caption.VB_Description = "gibt den Anzeigetext zurck oder legt ihn fest"
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
If Ambient.UserMode Then
    m_Caption = New_Caption
    PropertyChanged "Caption"
Else
    MsgBox "die Eigenschaft Caption mu als Laufzeit-Eigenschaft genutzt werden," _
    & vbCrLf & "da sonst die Ausfhrung evtl. langsamer wird !" _
    & vbCrLf & vbCrLf & "d.h. die Zeitanzeige berspringt ffter die eine oder andere Sekunde." _
    , vbInformation, Extender.Name
End If
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,8
Public Property Get FontSizeCaption() As Long
Attribute FontSizeCaption.VB_Description = "gibt die Schriftgre des Anzeigetextes zurck oder legt sie fest"
    FontSizeCaption = m_FontSizeCaption
End Property

Public Property Let FontSizeCaption(ByVal New_FontSizeCaption As Long)
On Error GoTo Fehlerbehandlung
    
    m_FontSizeCaption = New_FontSizeCaption
    If m_FontSizeCaption < 8 Then
        m_FontSizeCaption = 8
    End If

    Call Zeitwertanzeigen

    PropertyChanged "FontSizeCaption"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,false
Public Property Get FontBoldCaption() As Boolean
Attribute FontBoldCaption.VB_Description = "gibt die FontBold-Eigenschaft des Anzeigetextes zurck oder legt sie fest"
    FontBoldCaption = m_FontBoldCaption
End Property

Public Property Let FontBoldCaption(ByVal New_FontBoldCaption As Boolean)
    m_FontBoldCaption = New_FontBoldCaption

    Call Zeitwertanzeigen

    PropertyChanged "FontBoldCaption"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbblack
Public Property Get ColorCaption() As OLE_COLOR
Attribute ColorCaption.VB_Description = "gibt die Farbe des Anzeigetextes zurck oder legt sie fest"
    ColorCaption = m_ColorCaption
End Property

Public Property Let ColorCaption(ByVal New_ColorCaption As OLE_COLOR)
On Error GoTo Fehlerbehandlung

    m_ColorCaption = New_ColorCaption
    PropertyChanged "ColorCaption"

    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Legt ein benutzerdefiniertes Maussymbol fest."
    Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
On Error GoTo Fehlerbehandlung

    Set UserControl.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,MousePointer
Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Gibt den Typ des Mauszeigers zurck, der angezeigt wird, wenn dieser sich ber einem Teil eines Objekts befindet, oder legt diesen fest."
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
    UserControl.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=4,0,0,1.5
Public Property Get AbstandDot() As Double
Attribute AbstandDot.VB_Description = "gibt den Abstand der Dots (Vierecke) zum Rand zurck oder legt ihn fest"
    AbstandDot = m_AbstandDot
End Property

Public Property Let AbstandDot(ByVal New_AbstandDot As Double)
On Error GoTo Fehlerbehandlung

    m_AbstandDot = New_AbstandDot
    PropertyChanged "AbstandDot"
    
    Call Zeitwertanzeigen

Exit Property
Fehlerbehandlung:
MsgBox "ungltiger Eigenschaftswert !", vbCritical
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=13,0,0,
Public Property Get MultiLineToolTipText() As String
Attribute MultiLineToolTipText.VB_Description = "gibt den MultiLineToolTipText zurck oder legt ihn fest"
    MultiLineToolTipText = m_MultiLineToolTipText
End Property

Public Property Let MultiLineToolTipText(ByVal New_MultiLineToolTipText As String)
    m_MultiLineToolTipText = New_MultiLineToolTipText
    PropertyChanged "MultiLineToolTipText"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,&H00C0C0C0&
Public Property Get DisabledColor() As OLE_COLOR
Attribute DisabledColor.VB_Description = "gibt die DisabledColor-Eigenschaft zurck oder legt sie fest"
    DisabledColor = m_DisabledColor
End Property

Public Property Let DisabledColor(ByVal New_DisabledColor As OLE_COLOR)
    m_DisabledColor = New_DisabledColor
    Call Zeitwertanzeigen
    PropertyChanged "DisabledColor"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbblack
Public Property Get FocusColor() As OLE_COLOR
Attribute FocusColor.VB_Description = "gibt die Farbe des FocusRect zurck oder legt sie fest"
    FocusColor = m_FocusColor
End Property

Public Property Let FocusColor(ByVal New_FocusColor As OLE_COLOR)
    m_FocusColor = New_FocusColor
    PropertyChanged "FocusColor"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,2
Public Property Get FocusDrawStyle() As DrawStyleConstants
Attribute FocusDrawStyle.VB_Description = "gibt den FocusDrawStyle zurck oder legt ihn fest"
    FocusDrawStyle = m_FocusDrawStyle
End Property

Public Property Let FocusDrawStyle(ByVal New_FocusDrawStyle As DrawStyleConstants)
    m_FocusDrawStyle = New_FocusDrawStyle
    PropertyChanged "FocusDrawStyle"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,false
Public Property Get BooleanFocusRect() As Boolean
Attribute BooleanFocusRect.VB_Description = "legt fest ob ein FocusRect angezeigt werden soll"
    BooleanFocusRect = m_BooleanFocusRect
End Property

Public Property Let BooleanFocusRect(ByVal New_BooleanFocusRect As Boolean)
    m_BooleanFocusRect = New_BooleanFocusRect
    PropertyChanged "BooleanFocusRect"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,hWnd
Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Gibt eine Zugriffsnummer (von Microsoft Windows) auf ein Objektfenster zurck."
    hWnd = UserControl.hWnd
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,false
Public Property Get ZifferRmisch() As Boolean
Attribute ZifferRmisch.VB_Description = "gibt die Ziffernanzeige zurck (Rmisch bzw. Lateinisch) oder legt sie fest"
    ZifferRmisch = m_ZifferRmisch
End Property

Public Property Let ZifferRmisch(ByVal New_ZifferRmisch As Boolean)
    m_ZifferRmisch = New_ZifferRmisch
    Call Zeitwertanzeigen
    PropertyChanged "ZifferRmisch"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=8,0,0,420
Public Property Get AbstandStricheMitte() As Long
Attribute AbstandStricheMitte.VB_Description = "gibt den mittleren Abstand der Striche zum Rand zurck oder legt ihn fest"
    AbstandStricheMitte = m_AbstandStricheMitte
End Property

Public Property Let AbstandStricheMitte(ByVal New_AbstandStricheMitte As Long)
    m_AbstandStricheMitte = New_AbstandStricheMitte
    Call Zeitwertanzeigen
    PropertyChanged "AbstandStricheMitte"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=7,0,0,0
Public Property Get BorderStyle() As picBorderStyle
Attribute BorderStyle.VB_Description = "Gibt den Rahmenstil fr ein Objekt zurck oder legt diesen fest."
    BorderStyle = m_BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As picBorderStyle)
    m_BorderStyle = New_BorderStyle
    Select Case m_BorderStyle
        Case 0
            BorderStyleRaised Pic.hWnd, True
            Pic.BorderStyle = m_BorderStyle
            Mitte = Pic.Height / 2    'Die Mitte der PictureBox
        Case 1
            BorderStyleRaised Pic.hWnd, True
            Pic.BorderStyle = m_BorderStyle
            Mitte = (Pic.Height / 2) - 60    'Die Mitte der PictureBox
        Case 2
            Pic.BorderStyle = 0
            Mitte = (Pic.Height / 2) - 60    'Die Mitte der PictureBox
            BorderStyleRaised Pic.hWnd, False
        Case 3
            Pic.BorderStyle = 1
            Mitte = (Pic.Height / 2) - 75    'Die Mitte der PictureBox
            BorderStyleRaised Pic.hWnd, False
    End Select

    Call Zeitwertanzeigen
    
    PropertyChanged "BorderStyle"
End Property

